From 92c174f75c69f34e1c86c95766c1b0e7f8289a7a Mon Sep 17 00:00:00 2001
From: Alyssa Rosenzweig <alyssa@collabora.com>
Date: Tue, 2 Aug 2022 09:49:09 -0400
Subject: [PATCH] nir/lower_idiv: Reexpress bcsel/iadd
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

On Bifrost, we can fuse the b2i32 into the used-once comparison and save an
instruction. This should also be easier to schedule for other GPUs. shader-db on
Valhall:

total instructions in shared programs: 2736444 -> 2736007 (-0.02%)
instructions in affected programs: 243553 -> 243116 (-0.18%)
helped: 368
HURT: 1
helped stats (abs) min: 1.0 max: 5.0 x̄: 1.20 x̃: 1
helped stats (rel) min: 0.11% max: 1.22% x̄: 0.19% x̃: 0.15%
HURT stats (abs)   min: 4.0 max: 4.0 x̄: 4.00 x̃: 4
HURT stats (rel)   min: 1.91% max: 1.91% x̄: 1.91% x̃: 1.91%
95% mean confidence interval for instructions value: -1.24 -1.13
95% mean confidence interval for instructions %-change: -0.20% -0.17%
Instructions are helped.

total cycles in shared programs: 140629.16 -> 140629.05 (<.01%)
cycles in affected programs: 25.23 -> 25.12 (-0.43%)
helped: 3
HURT: 0
helped stats (abs) min: 0.015625 max: 0.078125 x̄: 0.04 x̃: 0
helped stats (rel) min: 0.20% max: 0.79% x̄: 0.40% x̃: 0.20%

total cvt in shared programs: 14836.97 -> 14830.14 (-0.05%)
cvt in affected programs: 2267.59 -> 2260.77 (-0.30%)
helped: 368
HURT: 1
helped stats (abs) min: 0.015625 max: 0.078125 x̄: 0.02 x̃: 0
helped stats (rel) min: 0.20% max: 2.08% x̄: 0.33% x̃: 0.25%
HURT stats (abs)   min: 0.0625 max: 0.0625 x̄: 0.06 x̃: 0
HURT stats (rel)   min: 3.05% max: 3.05% x̄: 3.05% x̃: 3.05%
95% mean confidence interval for cvt value: -0.02 -0.02
95% mean confidence interval for cvt %-change: -0.35% -0.29%
Cvt are helped.

total quadwords in shared programs: 1480656 -> 1480536 (<.01%)
quadwords in affected programs: 5024 -> 4904 (-2.39%)
helped: 15
HURT: 0
helped stats (abs) min: 8.0 max: 8.0 x̄: 8.00 x̃: 8
helped stats (rel) min: 1.61% max: 3.23% x̄: 2.48% x̃: 2.33%
95% mean confidence interval for quadwords value: -8.00 -8.00
95% mean confidence interval for quadwords %-change: -2.75% -2.20%
Quadwords are helped.

Signed-off-by: Alyssa Rosenzweig <alyssa@collabora.com>
---
 src/compiler/nir/nir_lower_idiv.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

diff --git a/src/compiler/nir/nir_lower_idiv.c b/src/compiler/nir/nir_lower_idiv.c
index 1f1c940e22f..b872ac06874 100644
--- a/src/compiler/nir/nir_lower_idiv.c
+++ b/src/compiler/nir/nir_lower_idiv.c
@@ -151,8 +151,7 @@ emit_udiv(nir_builder *bld, nir_ssa_def *numer, nir_ssa_def *denom, bool modulo)
       return nir_bcsel(bld, remainder_ge_den, nir_isub(bld, remainder, denom),
                        remainder);
    } else {
-      return nir_bcsel(bld, remainder_ge_den, nir_iadd_imm(bld, quotient, 1),
-                       quotient);
+      return nir_iadd(bld, quotient, nir_b2i32(bld, remainder_ge_den));
    }
 }
 
-- 
2.35.1

